/*
 ============================================================================
 Name        : gstreamerTest.c
 Author      : Klaus Jaensch
 Version     :
 Copyright   : Your copyright notice
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <glib-object.h>
#include <jni.h>
#include <gst/gst.h>
//#include <gst/audio/gstbaseaudiosink.h>

#include <gst/audio/gstaudiosink.h>

#include "jnm_audiosink.h"
//#include "jnm_decodingplayer.h"


G_DEFINE_TYPE_WITH_PRIVATE(JnmAudioSink, jnm_audiosink, GST_TYPE_AUDIO_SINK);
//GST_BOILERPLATE(JnmAudioSink, jnm_audiosink, GstAudioSink, GST_TYPE_AUDIO_SINK);
//GST_BOILERPLATE_FULL (GstMySink, gst_my_sink, GstBaseSink, GST_TYPE_BASE_SINK);


/* Define the private structure in the .c file */
//#define JNVIDEO_JVIDEOSINK_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE ((obj), JNVIDEO_TYPE_JVIDEOSINK, JnmAudiosinkPrivate))


// See: http://gstreamer.freedesktop.org/data/doc/gstreamer/head/pwg/html/section-types-definitions.html#table-audio-types

#define AUDIO_FORMATS_SIGNED_INT "{ S32LE, S32BE, S24LE, S24BE, S16LE, S16BE }"
static GstStaticPadTemplate gstSinkPadTemplate=
		GST_STATIC_PAD_TEMPLATE (
				"sink",
				GST_PAD_SINK,
				GST_PAD_ALWAYS,

				GST_STATIC_CAPS (
						 		    "audio/x-raw,format="AUDIO_FORMATS_SIGNED_INT",layout=interleaved"
						 		  )
		);

static void callJavaVoidMethod(JnmAudioSink *mdp, char * methodName) {
	JNIEnv *env;
	JavaVM *jvm = mdp->javaVM;
	if (jvm != NULL) {
		jint res = (*jvm)->AttachCurrentThread(jvm, (void **) &env, NULL);
		if (res == 0) {
			jclass cls = (*env)->GetObjectClass(env, mdp->javaObjRef);
			if (cls == NULL) {
				printf("Could not find class\n");
				return;
			}
			jmethodID mid = (*env)->GetMethodID(env, cls, methodName, "()V");
			if (mid == 0) {
				printf("Could not find method ID\n");
				return;
			}
			(*env)->CallVoidMethod(env, mdp->javaObjRef, mid);
			// should we detach here?
			(*jvm)->DetachCurrentThread(jvm);

		}
	}
}
/*static void jnm_audiosink_base_init(gpointer      g_class){

	GstPadTemplate *spt= gst_static_pad_template_get(&gstSinkPadTemplate);
	  gst_element_class_add_pad_template (g_class,spt);


}*/

/* Init functions */
static void jnm_audiosink_class_init (JnmAudioSinkClass *klass)
{

	//gobject_class = (GObjectClass *) klass;
	GstElementClass *gstelement_class = (GstElementClass *) klass;
	//gstbasesink_class = (GstBaseSinkClass *) klass;
	GstAudioSinkClass *audiosink_class = (GstAudioSinkClass *) klass;

	GstPadTemplate *spt= gst_static_pad_template_get(&gstSinkPadTemplate);
	gst_element_class_add_pad_template (gstelement_class,spt);
	// Gstreamer 1.8
	//GstStaticPadTemplate *spt= gst_static_pad_template_get(&gstSinkPadTemplate);
	//gst_element_class_add_static_pad_template (audiosink_class,spt);

	// TODO
	//parent_class = g_type_class_peek_parent (klass);
	//audiosink_class->show_frame = jnm_audiosink_show_frame;
	audiosink_class->open=jnm_audiosink_open;
	audiosink_class->prepare=jnm_audiosink_prepare;
	audiosink_class->write=jnm_audiosink_write;
	audiosink_class->delay=jnm_audiosink_delay;
	audiosink_class->reset=jnm_audiosink_reset;
	audiosink_class->unprepare=jnm_audiosink_unprepare;
	audiosink_class->close=jnm_audiosink_close;

	//gstbasesink_class->set_caps=jnm_audiosink_set_caps;

}



static void jnm_audiosink_init (JnmAudioSink *filter)
{

	filter->delay=0;
	// set the audio sink as clock causes choppy video
	// Update: caused by blocking audioWrite method
	//gst_base_audio_sink_set_provide_clock((GstBaseAudioSink *)filter,FALSE);
	//gst_base_audio_sink_set_drift_tolerance((GstBaseAudioSink *)filter,5000);
/*
	GValue btGval = {0, };
		 guint64 bt=500000;
		 // guint64 bt=200000;
		  g_value_init (&btGval, G_TYPE_UINT64);
		  g_value_set_uint64 (&btGval, bt);
		g_object_set_property((GObject *)filter,"buffer-time",&btGval);
*/
/*
	GValue dtGval = {0, };
	 guint64 dt=10000000;
	//guint64 dt=40000;
	  g_value_init (&dtGval, G_TYPE_UINT64);
	  g_value_set_uint64 (&dtGval, dt);
	g_object_set_property((GObject *)filter,"drift-tolerance",&dtGval);
*/
/*
	GValue dwGval = {0, };
		 guint64 dw=100000;
		//guint64 dt=40000;
		  g_value_init (&dwGval, G_TYPE_UINT64);
		  g_value_set_uint64 (&dwGval, dw);
		g_object_set_property((GObject *)filter,"discont-wait",&dwGval);
		*/
/*
	GValue ltGval = {0, };
		  guint64 lt=40000;
		  g_value_init (&ltGval, G_TYPE_UINT64);
		  g_value_set_uint64 (&ltGval, lt);
		g_object_set_property((GObject *)filter,"latency-time",&ltGval);
*/
    /* Initialize all public and private members to reasonable default values. */



    /* Initialize private fields */
   // JnmAudioSinkPrivate *priv;
    //self->priv = priv = JNVIDEO_JVIDEOSINK_GET_PRIVATE(self);
    //priv->hsize = 42;

    //g_print("  init'd private variable priv->hsize to %d\n", priv->hsize);


    /* If you need specific construction properties to complete initialization,
     * delay initialization completion until the property is set.
     */

   // GstElementClass *klass = GST_ELEMENT_CLASS (filter_klass);

      /* pad through which data comes in to the element */

      /* properties initial value */
      //filter->silent = FALSE;


}

/*
gboolean      jnm_audiosink_set_caps (GstBaseSink *base_sink, GstCaps *caps){

	 return jnm_decodingplayer_set_caps(((JnmAudioSink *)base_sink)->mediaDecodingPlayer,caps);
}

*/

gboolean jnm_audiosink_open(GstAudioSink *sink){
	//g_print("audio opened\n");

return TRUE;
}
 /* prepare resources and state to operate with the given specs */
 gboolean jnm_audiosink_prepare(GstAudioSink *sink, GstAudioRingBufferSpec *spec){
	 JnmAudioSink *as=(JnmAudioSink *)sink;

	 //g_print("audio prepare\n");
	 //g_print("segsize %d count %d\n",spec->segsize,spec->segtotal);
	 //spec->segsize=1920;
	 //spec->segtotal=20;
	 gint bufferSize=spec->segsize*spec->segtotal;
	 //gboolean open= jnm_decodingplayer_audiosink_open(s->mediaDecodingPlayer,spec->rate,spec->bytes_per_sample,spec->channels,spec->bigend,bufferSize);

	 JNIEnv *env;
	 		JavaVM *jvm = as->javaVM;
	 		jint res = (*jvm)->AttachCurrentThread(jvm, (void **) &env, NULL);
	 			if (res == 0) {

	 				jclass cls = (*env)->GetObjectClass(env, as->javaObjRef);
	 				if (cls == NULL) {
	 					printf("Could not find class\n");
	 					return FALSE;
	 				}
	 				jmethodID mid = (*env)->GetMethodID(env, cls, "audioOpen",
	 						"(IIIZI)Z");
	 				if (mid == 0) {
	 					printf("Could not find method ID\n");
	 					return FALSE;
	 				}
	 				const GstAudioInfo aInfo=spec->info;
	 				const GstAudioFormatInfo* afInfo=aInfo.finfo;
	 				// aInfo.bpf is in Java terms bytes per frame
	 				jboolean bigEndian=GST_AUDIO_FORMAT_INFO_IS_BIG_ENDIAN(afInfo);
	 				jboolean success=(*env)->CallBooleanMethod(env, as->javaObjRef,
	 						mid,aInfo.rate,aInfo.bpf,aInfo.channels,bigEndian,bufferSize);
	 				(*jvm)->DetachCurrentThread(jvm);
	 				return success;
	 			}
	 			printf("audiosink open failed!\n");
	 			fflush(stdout);
	 			return FALSE;
 }
 /* undo anything that was done in prepare() */
 gboolean jnm_audiosink_unprepare(GstAudioSink *sink){
	 //g_print("Audio unprepare\n");
	 return TRUE;
 }
 /* close the device */
 gboolean jnm_audiosink_close(GstAudioSink *sink){
	 JnmAudioSink *as=(JnmAudioSink *)sink;
	 //return jnm_decodingplayer_audiosink_close(s->mediaDecodingPlayer);
	 JNIEnv *env;
	 		JavaVM *jvm = as->javaVM;
	 		jint res = (*jvm)->AttachCurrentThread(jvm, (void **) &env, NULL);
	 			if (res == 0) {

	 				jclass cls = (*env)->GetObjectClass(env, as->javaObjRef);
	 				if (cls == NULL) {
	 					printf("Could not find class\n");
	 					return FALSE;
	 				}
	 				jmethodID mid = (*env)->GetMethodID(env, cls, "audioClose",
	 						"()Z");
	 				if (mid == 0) {
	 					printf("Could not find method ID\n");
	 					return FALSE;
	 				}

	 				jboolean success=(*env)->CallBooleanMethod(env, as->javaObjRef,mid);
	 				(*jvm)->DetachCurrentThread(jvm);

	 				as->audioDelayNativeThreadID=0;
	 				as->audioNativeThreadID=0;
	 				return success;
	 			}
	 			return FALSE;


 }
 /* write samples to the device */
 /* FIXME 0.11: change return value to gint, as most implementation use that
  * already anyway */
 gint jnm_audiosink_write(GstAudioSink *sink, gpointer data, guint length){

	// g_print("audio write %d\n",length);
	 JnmAudioSink *as=(JnmAudioSink *)sink;
	 //s->delay+=length;
	// return jnm_decodingplayer_audiosink_write(s->mediaDecodingPlayer,data,length);
	 pthread_t currNativeThreadId=pthread_self();
	 		JNIEnv *env=as->audioJEnv;
	 		JavaVM *jvm = as->javaVM;

	 		if(as->audioNativeThreadID!=currNativeThreadId){
	 			//g_print("Attaching audio thread\n");
	 			jint res = (*jvm)->AttachCurrentThread(jvm, (void **) &env, NULL);

	 			if (res == 0) {
	 				as->audioNativeThreadID=currNativeThreadId;
	 				as->audioJEnv=env;
	 			}else{
	 				as->audioJEnv=NULL;
	 				env=NULL;
	 			}
	 		}
	 		if(env!=NULL){

	 			jsize dataLength = length;
	 			jbyteArray audioBufArr=(*env)->NewByteArray(env,dataLength);

	 			(*env)->SetByteArrayRegion(env,audioBufArr, 0, length, data);
	 			jint written=(*env)->CallIntMethod(env, as->javaObjRef,
	 					(jmethodID) as->jaudioWriteMethodId,audioBufArr);


	 			(*env)->ReleaseByteArrayElements(env,audioBufArr,data,JNI_COMMIT);
	 			//(*env)->ReleaseByteArrayElements(env,audioBufArr,NULL,0);
	 			// the (*env)->ReleaseByteArrayElements() call does not free the local reference!
	 			// see
	 			(*env)->DeleteLocalRef(env,audioBufArr);

	 			return written;
	 			//return 0;
	 		}else{
	 			g_print("Could not write audio\n");
	 		}
	 		g_print("Could not write audio\n");
	 		return 0;

 }
 /* get number of samples queued in the device */
 guint   jnm_audiosink_delay(GstAudioSink *sink){
	// g_print("audio delay query\n");
	 JnmAudioSink *as=(JnmAudioSink *)sink;
	 	// return jnm_decodingplayer_audiosink_delay(s->mediaDecodingPlayer);
	 	pthread_t currNativeThreadId=pthread_self();
	 				JNIEnv *env=as->audioDelayEnv;
	 				JavaVM *jvm = as->javaVM;
	 				if(as->audioDelayNativeThreadID!=currNativeThreadId){
	 					//g_print("Attaching audio thread (delay)\n");
	 					jint res = (*jvm)->AttachCurrentThread(jvm, (void **) &env, NULL);

	 					if (res == 0) {
	 						as->audioDelayNativeThreadID=currNativeThreadId;
	 						as->audioDelayEnv=env;
	 					}else{
	 						as->audioJEnv=NULL;
	 						env=NULL;
	 						g_print("Could not attach audio delay thread to JVM\n");
	 						return 0;
	 					}
	 				}
	 				if(env!=NULL){
	 					jint delay=(*env)->CallLongMethod(env, as->javaObjRef,
	 							(jmethodID) as->jaudioDelayMethodId);
	 					//(*jvm)->DetachCurrentThread(jvm);
	 					return delay;
	 				}else{

	 					g_printerr("Could not get JVM environment!\n");
	 				}
	 				return 0;
 }
 /* reset the audio device, unblock from a write */
 void    jnm_audiosink_reset(GstAudioSink *sink){
	 //g_print("audio reset\n");
	 JnmAudioSink *as=(JnmAudioSink *)sink;
	 //jnm_decodingplayer_audiosink_reset(s->mediaDecodingPlayer);
	 callJavaVoidMethod(as,"audioReset");
 }

 static void jnm_audiosink_release(JnmAudioSink *as){
 	gst_object_unref(GST_OBJECT (as));

 }

 JNIEXPORT jobject JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_init(JNIEnv *env, jobject jobj) {
 	//gint argc = 0;
 	//char **argv;
 	//gst_init(&argc, &argv);
 	jobject nativePointer = NULL;
 	JavaVM *javaVM;
 	jint res = (*env)->GetJavaVM(env, &javaVM);
 	if (res == 0) {

 		JnmAudioSink *jnmAudioSink = g_object_new(
 				jnm_audiosink_get_type(), NULL);
 		/*
 		jclass exceptionCls = (*env)->FindClass(env,
 				"de/klausj/media/NativeMediaSystemException");
 		if (exceptionCls == NULL) {
 			printf("Could not find exception class\n");
 			return NULL;
 		}
 		exceptionClassRef = (*env)->NewWeakGlobalRef(env, exceptionCls);
 		*/
 		jnmAudioSink->javaVM = javaVM;
 		jnmAudioSink->javaObjRef = (*env)->NewGlobalRef(env, jobj);

 		nativePointer = (*env)->NewDirectByteBuffer(env, jnmAudioSink,
 				sizeof(JnmAudioSink));
 		jclass cls = (*env)->GetObjectClass(env, jnmAudioSink->javaObjRef);
 		if (cls == NULL) {
 			printf("Could not find class\n");
 			return NULL;
 		}
 		jnmAudioSink->jClassRef=(*env)->NewGlobalRef(env,cls);

 		jnmAudioSink->jaudioWriteMethodId = (*env)->GetMethodID(env, cls, "audioWrite", "([B)I");
		if (jnmAudioSink->jaudioWriteMethodId == 0) {
			printf("Could not find method ID\n");
			return NULL ;
		}


		jnmAudioSink->jaudioDelayMethodId = (*env)->GetMethodID(env, cls, "audioDelay", "()I");
		if (jnmAudioSink->jaudioDelayMethodId == 0) {
			printf("Could not find method ID\n");
			return NULL ;
		}

 	}
 	return nativePointer;
 }

 JNIEXPORT void JNICALL Java_de_klausj_video_impl_gstreamer_AudioSink_release(
 		JNIEnv *env, jobject jobj, jobject nativePointer) {
 	JnmAudioSink *jnmAudioSink = (*env)->GetDirectBufferAddress(env,
 			nativePointer);
 	jnm_audiosink_release(jnmAudioSink);
 	(*env)->DeleteGlobalRef(env, jnmAudioSink->javaObjRef);
 	(*env)->DeleteGlobalRef(env, jnmAudioSink->jClassRef);


 }
