/*
 ============================================================================
 Name        : gstreamerTest.c
 Author      : Klaus Jaensch
 Version     :
 Copyright   : Your copyright notice
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>

#include <gst/gst.h>
#include <gst/video/gstvideosink.h>

#include "jnm_videosink.h"
#include "jnm_decodingplayer.h"


//G_DEFINE_TYPE (JnmVideosink, jnvideo_jvideosink, G_TYPE_OBJECT);
//GST_BOILERPLATE(JnmVideoSink, jnm_videosink, GstVideoSink, GST_TYPE_VIDEO_SINK);
G_DEFINE_TYPE_WITH_PRIVATE(JnmVideoSink, jnm_videosink,GST_TYPE_VIDEO_SINK);
//GST_BOILERPLATE_FULL (GstMySink, gst_my_sink, GstBaseSink, GST_TYPE_BASE_SINK);


/* Define the private structure in the .c file */
//#define JNVIDEO_JVIDEOSINK_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE ((obj), JNVIDEO_TYPE_JVIDEOSINK, JnmVideosinkPrivate))

// See: http://gstreamer.freedesktop.org/data/doc/gstreamer/head/pwg/html/section-types-definitions.html#table-video-types

static GstStaticPadTemplate gstSinkPadTemplate=
		GST_STATIC_PAD_TEMPLATE (
				"sink",
				GST_PAD_SINK,
				GST_PAD_ALWAYS,
/*
		  GST_STATIC_CAPS (
		    "video/x-raw-rgb, bpp=32, depth=24, endianness=(int)4321,red_mask=(int)0xFF00, green_mask=(int)0xFF0000, blue_mask=(int)0xFF000000"
		  )
*/
/*
				GST_STATIC_CAPS (
						"video/x-raw-rgb, bpp=32, depth=24, endianness=(int)4321,red_mask=(int)0xFF000000, green_mask=(int)0x00FF0000, blue_mask=(int)0x0000FF00"
				)
*/
				GST_STATIC_CAPS (
						 		    "video/x-raw-rgb"
									//"video/x-raw-yuv"
						 		  )
				// BGR format does not work
				/*
		  GST_STATIC_CAPS (
		 		  		    "video/x-raw-rgb, bpp=24, depth=24, endianness=(int)321,red_mask=(int)0xFF0000, green_mask=(int)0x00FF00, blue_mask=(int)0x0000FF"
		 		  		  )
				 */
				 //GST_STATIC_CAPS_ANY
				/*
		  GST_STATIC_CAPS (
		 		    "video/x-raw-yuv"
		 		  )
				 */
		);

static void jnm_videosink_base_init(gpointer      g_class){
	GstPadTemplate *spt= gst_static_pad_template_get(&gstSinkPadTemplate);
	  gst_element_class_add_pad_template (g_class,spt);
	  // see GstElementDetails
	  //gst_element_class_set_details (g_class, &details);

}

/* Init functions */
static void jnm_videosink_class_init (JnmVideoSinkClass *klass)
{

	GstBaseSinkClass *gstbasesink_class;
	GstVideoSinkClass *videosink_class;

	//GObjectClass *gobject_class = (GObjectClass *) klass;
	//GstElementClass *gstelement_class = (GstElementClass *) klass;
	gstbasesink_class = (GstBaseSinkClass *) klass;
	videosink_class = (GstVideoSinkClass *) klass;
	// TODO
	//parent_class = g_type_class_peek_parent (klass);
	videosink_class->show_frame = jnm_videosink_show_frame;
	gstbasesink_class->set_caps=jnm_videosink_set_caps;

}



static void jnm_videosink_init (JnmVideoSink *filter)
{
    /* Initialize all public and private members to reasonable default values. */
    /* Initialize private fields */
    /* If you need specific construction properties to complete initialization,
     * delay initialization completion until the property is set.
     */
}


gboolean jnm_videosink_set_caps (GstBaseSink *base_sink, GstCaps *caps){
	return jnm_decodingplayer_set_caps(((JnmVideoSink *)base_sink)->mediaDecodingPlayer,caps);
}

GstFlowReturn  jnm_videosink_show_frame(GstVideoSink *video_sink, GstBuffer *buf){
	JnmVideoSink * jnm_video_sink=(JnmVideoSink*)video_sink;
	return jnm_decodingplayer_show_frame(jnm_video_sink->mediaDecodingPlayer,buf);
}



